# Class ShapeRenderer

java.lang.Object
org.jmol.render.ShapeRenderer

Direct Known Subclasses:
  `BackboneRenderer, BallsRenderer, DipolesRenderer, DotsRenderer, EllipsoidsRenderer, FontLineShapeRenderer, FrankRenderer, HalosRenderer, HoverRenderer, MeshRenderer, PolyhedraRenderer, StarsRenderer, StrandsRenderer, VectorsRenderer`

public abstract class ShapeRenderer extends Object

## Field Summary

Fields
Modifier and Type
Field
Description
`short`
`colix`
`int`
`exportType`
`protected int`
`flags`
`JmolRendererInterface`
`g3d`
could be vwr.gdata or an exporter
`boolean`
`isExport`
`short`
`mad`
`protected ModelSet`
`ms`
`protected int`
`myVisibilityFlag`
`protected Shape`
`shape`
`protected int`
`shapeID`
`protected TransformManager`
`tm`
`Viewer`
`vwr`

## Constructor Summary

Constructors
Constructor
Description
`ShapeRenderer()`

## Method Summary

Modifier and Type
Method
Description
`protected void`
`initRenderer()`
`protected boolean`
`isVisibleForMe(Atom a)`
`protected abstract boolean`
`render()`
`boolean`
`renderShape(JmolRendererInterface g3d, ModelSet modelSet, Shape shape, int flags)`
`void`
`setup(JmolRendererInterface g3d, ModelSet modelSet, Shape shape)`
`final void`
`setViewerG3dShapeID(Viewer vwr, int shapeID)`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### vwr

public Viewer vwr

### tm

protected TransformManager tm

### g3d

public JmolRendererInterface g3d
could be vwr.gdata or an exporter

### ms

protected ModelSet ms

### shape

protected Shape shape

### myVisibilityFlag

protected int myVisibilityFlag

### shapeID

protected int shapeID

### colix

public short colix

### mad

public short mad

### exportType

public int exportType

### isExport

public boolean isExport

### flags

protected int flags

## Constructor Details

### ShapeRenderer

public ShapeRenderer()

## Method Details

### initRenderer

protected void initRenderer()

### render

protected abstract boolean render()

### setViewerG3dShapeID

public final void setViewerG3dShapeID(Viewer vwr, int shapeID)

### renderShape

public boolean renderShape(JmolRendererInterface g3d, ModelSet modelSet, Shape shape, int flags)

### setup

public void setup(JmolRendererInterface g3d, ModelSet modelSet, Shape shape)

### isVisibleForMe

protected boolean isVisibleForMe(Atom a)